//---------------------------------------------------------------------------
//PrnDib Copyright (c) 1989-2000 by Joe C. Hecht All Rights Reserved
//License - Distribution of this souce code prohibited!
//For inclusion in compiled form in your application only!
//Version 3.0 - Use at your own risk - No liability accepted!
//TExcellentHomePage: www.code4sale.com/joehecht
//Author email: joehecht@code4sale.com
//Code4Sale.com - You place to buy and sell code! www.code4sale.com

#ifndef PrnDibH
#define PrnDibH

#pragma hdrstop

#include <Windows.h>


#define PRINT_SUCCESSFUL 1
#define NOTHING_TO_PRINT 0
#define BAD_PARAMETER -1
#define MEMORY_ALLOC_FAILED -2
#define MEMORY_READ_FAILED -3
#define MEMORY_WRITE_FAILED -4
#define USER_ABORT_OR_OTHER_ERROR -5


typedef BOOL __stdcall (*TAppCallbackFn)(DWORD UnitsDone,   //Number of units completed
                                         DWORD TotalUnits,  //Number of total units to print
                                         DWORD UserData);   //Application defined data or pointer.

int __stdcall PrintDIBitmap(HDC dc,
                            BITMAPINFO * lpBitmapInfo,
                            void * lpBits,
                            BOOL Centered,
                            BOOL UsePerfectMargins);


int __stdcall PrintDIBitmapCB(HDC dc,
                              BITMAPINFO * lpBitmapInfo,
                              void * lpBits,
                              BOOL Centered,
                              BOOL UsePerfectMargins,
                              TAppCallbackFn OnAppCallbackFn,
                              DWORD OnAppCallbackData);

int __stdcall PrintDIBitmapXY(HDC dc,
                              int dstx,
                              int dsty,
                              int dstWidth,
                              int dstHeight,
                              BITMAPINFO * lpBitmapInfo,
                              void * lpBits);

int __stdcall PrintDIBitmapEx(HDC dc,
                              int dstx,
                              int dsty,
                              int dstWidth,
                              int dstHeight,
                              int srcx,
                              int srcy,
                              int srcWidth,
                              int srcHeight,
                              BITMAPINFO * lpBitmapInfo,
                              void * lpBits,
                              HPALETTE Palette,
                              BOOL ForcePalette,
                              BOOL DoNotUsePalette,
                              RECT * DeviceClipRect,
                              TAppCallbackFn OnAppCallbackFn,
                              DWORD OnAppCallbackData);

void __stdcall PrnDIBSetDebugMsg(BOOL value);

void __stdcall PrnDIBSetDebugBltCode(BOOL value);

void __stdcall PrnDIBSetDebugBlt(BOOL value);

void __stdcall PrnDIBSetDebugUseDDB(BOOL value);

void __stdcall PrnDIBSetDebugAutoUseDDB(BOOL value);

void __stdcall PrnDIBSetDebugFrames(BOOL value);

void __stdcall PrnDIBSetDebugPaletteNone();

void __stdcall PrnDIBSetDebugPaletteForce();

void __stdcall PrnDIBSetDebugPaletteNotAllowed();

void __stdcall PrnDIBSetDebugDcSaves(BOOL value);

void __stdcall PrnDIBSetDebugGdiFlush(BOOL value);

void __stdcall PrnDIBSetSleepValue(int value);

HWND __fastcall PrnDIBSetAbortDialogHandle(HWND value);

void __stdcall PrnDIBSetOutputScaleFactor(int x,
                                          int y);

void __stdcall PrnDIBSetDoWinScale(BOOL value);


#endif
